// ExtPackageShape.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ExtPackageShape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CExtPackageShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CExtPackageShape, CFORectShape, 0)
CExtPackageShape::CExtPackageShape()
{
	SetType(EXT_PACKAGE_SHAPE);
	SetPolyObject(FALSE);
	SetRotateProtect(TRUE);

	ShowFontProp(TRUE);
//	SetNullPen(TRUE);
	SetPointSize(10);
	m_bShowLabelAtFirst = TRUE;

	SetWeight(700);

}

CExtPackageShape::CExtPackageShape(const CExtPackageShape& src)
{
	*this = src;
}

CExtPackageShape::~CExtPackageShape()
{

}

/////////////////////////////////////////////////////////////////////////////
// CExtPackageShape diagnostics

#ifdef _DEBUG
void CExtPackageShape::AssertValid() const
{
	CFORectShape::AssertValid();
}

void CExtPackageShape::Dump(CDumpContext& dc) const
{
	CFORectShape::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CExtPackageShape::Create(CRect &rcPos,CString strCaption)
{
	CFORectShape::Create(rcPos,strCaption);

	// FODO: Add your own code here.

}

void CExtPackageShape::Serialize(CArchive& ar)
{
	CFORectShape::Serialize(ar);
	if(ar.IsStoring())
	{
		//FODO:Add your own code here.

	}
	else
	{
		//FODO:Add your own code here.

	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CExtPackageShape::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
								 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CExtPackageShape::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CExtPackageShape::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}

BOOL CExtPackageShape::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;        // success
}

CExtPackageShape& CExtPackageShape::operator=(const CExtPackageShape& src)
{
	(*(CFORectShape*)this) = src;
	return (*this);
}

CFODrawShape* CExtPackageShape::Copy() const
{
	return (new CExtPackageShape(*this));
}

void CExtPackageShape::PrepareDC(CDC* pDC)
{
	CFORectShape::PrepareDC(pDC);

	//FODO:Add your own code below.
	
}

void CExtPackageShape::OnDrawTrackCustom(CDC *pDC)
{
	CFORectShape::OnDrawTrackCustom(pDC);

	// Add your own code here.

}

void CExtPackageShape::OnDrawShadow(CDC *pDC)
{
	CFORectShape::OnDrawShadow(pDC);
	
	//FODO:Add your own code below.
	
}

void CExtPackageShape::OnDrawFlat(CDC *pDC)
{
	CFODrawShape::OnDrawFlat(pDC);

	//FODO:Add your own code below.
	int cutoff = 8;
	FOPRect rect = GetDrawRect();
	CRect tabbox( rect );
	CRect bigbox( rect );

	tabbox.left += cutoff;
	tabbox.bottom = tabbox.top + cutoff * 2;
	tabbox.right = tabbox.left + cutoff * 8;

	if( tabbox.right > rect.right )
		tabbox.right = rect.right - cutoff;

	bigbox.top = tabbox.bottom - 1;

	pDC->Rectangle( tabbox );
	pDC->Rectangle( bigbox );
}

void CExtPackageShape::OnDraw3d(CDC *pDC)
{
	CFODrawShape::OnDraw3d(pDC);

	//FODO:Add your own code below.
	//FODO:Add your own code below.
	int cutoff = 8;
	FOPRect rect = GetDrawRect();
	CRect tabbox( rect );
	CRect bigbox( rect );

	tabbox.left += cutoff;
	tabbox.bottom = tabbox.top + cutoff * 2;
	tabbox.right = tabbox.left + cutoff * 8;

	if( tabbox.right > rect.right )
		tabbox.right = rect.right - cutoff;

	bigbox.top = tabbox.bottom - 1;

	pDC->Rectangle( tabbox );
	pDC->Rectangle( bigbox );
}

void CExtPackageShape::ClearDC(CDC* pDC)
{
	CFORectShape::ClearDC(pDC);

	//FODO:Add your own code below.

}

void CExtPackageShape::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CFORectShape::OnLButtonDown(nFlags,point);
	
	//FODO:Add your own code below.

}

void CExtPackageShape::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CFORectShape::OnLButtonUp(nFlags,point);

	//FODO:Add your own code below.

}

void CExtPackageShape::GeometryUpdated(CFOArea* pRgn)
{
	CFORectShape::GeometryUpdated(pRgn);

	//FODO:Add your own code below.

}
